SystemOrganization addCategory: #'TP2-TADP'!
SystemOrganization addCategory: #'TP2-TADP-Tests'!

Object subclass: #ComposicionATrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 00:09'!
agregarMetodosDeLaClase: unaClase AlTrait:unTrait ConClaseDeJerarquia:unaClaseConJerarquia

	| implementacionDeMetodos |
	
	implementacionDeMetodos := Set new.
	unaClase methodDictionary do:[:unMetodo| implementacionDeMetodos add: unMetodo getSource].
	
	implementacionDeMetodos do:[ :unaImplementacion | unTrait compile: unaImplementacion ].
	
	unaClase superclass name = unaClaseConJerarquia name
	ifTrue: [ unaClase superclass methodDictionary do:[ :unaImplementacion | unTrait compile: unaImplementacion ]].
	
	
	! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/3/2013 22:20'!
asignarUsoDelTrait: unTrait aLaClaseConNombre: unNombreDeClase

	| unSymbol |
	
	unSymbol := unNombreDeClase asSymbol.
	
	Object subclass: unSymbol
	uses: unTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'.! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/3/2013 22:20'!
componerEnTraitsLaClase:unaClase conNombreDeAtributoComposicion:unNombreDeAtributo conClaseConJerarquia:unaClaseConJerarquia
		
		self crearTraitsDeClaseConJearquia:unaClaseConJerarquia.
		self asignarUsoDelTrait: ('Trait',unaClaseConJerarquia name)  aLaClaseConNombre: unaClase name.
		self eliminarAtributoConNombre: unNombreDeAtributo DeLaClase:unaClase.! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 01:24'!
crearTraitConNombre:unNombreDeTrait
 
		| unSymbol |
		
		unSymbol :=('Trait', unNombreDeTrait) asSymbol.
		
		Trait named: unSymbol
       			uses: {}
       			category: 'TP2-TADP'.! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/3/2013 23:32'!
crearTraitsDeClaseConJearquia:unaClaseConJerarquia
	
		|traitsACrear|
		
		traitsACrear:=Set new.
		traitsACrear add: unaClaseConJerarquia.
		unaClaseConJerarquia allSubclasses do: [ :unaSubClase | traitsACrear add: unaSubClase].
		traitsACrear do:[ :unaClaseQueVaASerUnTrait | self crearTraitConNombre: unaClaseQueVaASerUnTrait name;
															 agregarMetodosDeLaClase: unaClaseQueVaASerUnTrait 
															 AlTrait: (Smalltalk at:(('Trait', unaClaseQueVaASerUnTrait name) asSymbol)) ConClaseDeJerarquia:unaClaseConJerarquia].
		
		! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/3/2013 22:21'!
eliminarAtributoConNombre: unNombreDeAtributo DeLaClase:unaClase

		unaClase removeInstVarNamed:unNombreDeAtributo.! !

Object subclass: #MetaUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!MetaUtil class methodsFor: 'as yet unclassified' stamp: 'Demian 9/8/2012 00:29'!
recreateCategory: categoryName
	(SystemOrganization listAtCategoryNamed: categoryName) do: [ :typeName | Smalltalk removeClassNamed: typeName ].
	SystemOrganization removeCategory: categoryName.
	FileStream fileIn: categoryName , '.st'.
	SystemOrganization sortCategories! !

Object subclass: #TheBlob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

Object subclass: #TheInterceptor
	instanceVariableNames: 'afterCode beforeCode theClasses theMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:18'!
addACategory: unaCategoriaString
	theClasses addAll: (Object subclasses select: [ :aClass | aClass category == (unaCategoriaString asSymbol)]).

! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:28'!
addClasses: anString
	| classesNames |
	classesNames := anString subStrings: ' '.
	theClasses addAll: (classesNames collect: [ :name | Compiler evaluate: name]).! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
agregarCodigo
	| codes |
	codes := self getTheMethods collect: [ :method | self getBeforeCode , method sourceCode, self getAfterCode ].
	^codes! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:45'!
getAfterCode
	
	^ afterCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
getBeforeCode
	
	^ beforeCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:24'!
getTheClasses
	
	^ theClasses! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
getTheMethods
	
	^ theMethods! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:27'!
initialize 
	theClasses := Bag new.
	theMethods := Bag new.! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:35'!
methodsBeginWith: anString
	| allMethods |
	allMethods := (theClasses collect: [ :aClass | aClass methods]).
	^ allMethods gather: [ :arrayMethods | arrayMethods select:  [:aMethod | (aMethod selector beginsWith: anString asSymbol)]].! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:37'!
selectAccessors
	theMethods addAll: (self methodsBeginWith: 'set').
	theMethods addAll: (self methodsBeginWith: 'get').! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:36'!
selectMethodsBeginWith: anString
	theMethods addAll: (self methodsBeginWith: anString)! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:46'!
setAfterCode: anObject
	
	afterCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
setBeforeCode: anObject
	
	beforeCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:23'!
setTheClasses: anObject
	
	theClasses := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
setTheMethods: anObject
	
	theMethods := anObject! !

TestCase subclass: #RefactorsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

RefactorsTest subclass: #ComposicionATraitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 01:31'!
setUp
	
	ComposicionATrait crearTraitConNombre:'TestUno'.
	
	"Creo una Clase para que en un asignarUsoDeTraitAUnaClaseTest el trait use esta clase"
	
	Object  subclass: #ClaseTest
 		instanceVariableNames: ''
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP'.
	
	Object  subclass: #ClaseTestA
 		instanceVariableNames: ''
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP'.
	
		
	(Smalltalk at:#ClaseTestA) subclass: #ClaseTestB
 		instanceVariableNames: ''
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP'.
		
	(Smalltalk at:#ClaseTestA)  subclass: #ClaseTestC
 		instanceVariableNames: ''
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP'.
		
	"Creo Metodos"
	(Smalltalk at:#ClaseTest)  compile:  'm0
	^0.'.
	(Smalltalk at:#ClaseTestA)  compile:  'm1
	^1.'.
	(Smalltalk at:#ClaseTestB)  compile:  'm2
	^2.'.
	(Smalltalk at:#ClaseTestC) compile:  'm3
	^3.'.
		! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 01:37'!
tearDown
	
	(Smalltalk at:#ClaseTest) removeFromSystem.
	(Smalltalk at:#ClaseTestA) removeFromSystem.
	(Smalltalk at:#ClaseTestB) removeFromSystem.
	(Smalltalk at:#ClaseTestC) removeFromSystem.
	
	(Smalltalk at:#TraitTestUno) removeFromSystem.
	! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 01:32'!
testAsignarUsoDeTraitAUnaClase
	
	| testClass testTrait|
	
	testClass := Smalltalk at:#ClaseTest.
	testTrait := Smalltalk at:#TraitTestUno.
		
	"Es necesario asegurarme que el trait tenga comportamiento y NO este vacio porque sino cuando haga que una clase lo use va a romper"
	ComposicionATrait agregarMetodosDeLaClase: testClass AlTrait: testTrait ConClaseDeJerarquia: testClass.
	
	ComposicionATrait asignarUsoDelTrait: testTrait  aLaClaseConNombre: testClass name.
	
	self assert: testClass methodDictionary size equals: testTrait methodDictionary size.
	! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 01:32'!
testCopiarMetodosDeUnaClaseAUnTrait

	| testTrait unDiccionario |
	
	testTrait := Smalltalk at:#TraitTestUno.
	
	ComposicionATrait agregarMetodosDeLaClase: (Smalltalk at:#ClaseTest) AlTrait: testTrait ConClaseDeJerarquia: (Smalltalk at:#ClaseTest).
	
	unDiccionario :=  (Smalltalk at:#TraitTest) methodDictionary.
	
	self assert: (((Smalltalk at:#ClaseTest) methodDictionary) size) equals: ((testTrait methodDictionary) size).! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 01:33'!
testCrearTrait

	| testTrait |
	
	testTrait := Smalltalk at:#TraitTestUno.
	
	self assert: #TraitTestUno equals: (testTrait name) asSymbol .! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 01:38'!
testCrearTraitsConMetodosAPartirDeClaseConJerarquia

	ComposicionATrait crearTraitsDeClaseConJearquia: (Smalltalk at:#ClaseTestA).
	
	self assert:   (Smalltalk at:#TraitClaseTestA) methodDictionary size equals: 1.
	self assert:   (Smalltalk at:#TraitClaseTestB) methodDictionary size equals: 2.
	self assert:   (Smalltalk at:#TraitClaseTestC) methodDictionary size equals: 2.	
		
		
	"Lo logico seria que vaya en el TearDown pero a Pharo no le gusta."
	(Smalltalk at:#TraitClaseTestA) removeFromSystem.
	(Smalltalk at:#TraitClaseTestB) removeFromSystem.
	(Smalltalk at:#TraitClaseTestC) removeFromSystem.! !

!RefactorsTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 4/30/2013 01:17'!
setUp
	MetaUtil recreateCategory: 'TP2-TADP'! !

RefactorsTest subclass: #TheBlobTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!TheBlobTest commentStamp: '<historical>' prior: 0!
A TheBlobTest is a test class for testing the behavior of TheBlob!
